---
title: AudioNode.connect()
slug: Web/API/AudioNode/connect
tags:
  - API
  - Audio
  - AudioNode
  - Media
  - Method
  - Reference
  - Web Audio API
  - connect
---
<p>{{ APIRef("Web Audio API") }}</p>

<div>
<p>The <code>connect()</code> method of the {{ domxref("AudioNode") }} interface lets you connect one of the node's outputs to a target, which may be either another <code>AudioNode</code> (thereby directing the sound data to the specified node) or an {{domxref("AudioParam")}}, so that the node's output data is automatically used to change the value of that parameter over time.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>destinationNode</em> = <em>AudioNode</em>.connect(<em>destination</em>, <em>outputIndex</em>, <em>inputIndex</em>);

<em>AudioNode</em>.connect(<em>destination</em>, <em>outputIndex</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>destination</code></dt>
 <dd>The {{domxref("AudioNode")}} or {{domxref("AudioParam")}} to which to connect.</dd>
 <dt><code>outputIndex</code> {{optional_inline}}</dt>
 <dd>An index specifying which output of the current <code>AudioNode</code> to connect to the destination. The index numbers are defined according to the number of output channels (see <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Audio_channels">Audio channels</a>). While you can only connect a given output to a given input once (repeated attempts are ignored), you can connect an output to multiple inputs by calling <code>connect()</code> repeatedly. This makes <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Fan-in_and_Fan-out">fan-out</a> possible. The default value is 0.</dd>
 <dt><code>inputIndex</code> {{optional_inline}}</dt>
 <dd>An index describing which input of the destination you want to connect the current <code>AudioNode</code> to; the default is 0. The index numbers are defined according to the number of input channels (see <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Audio_channels">Audio channels</a>). It is possible to connect an <code>AudioNode</code> to another <code>AudioNode</code>, which in turn connects back to the first <code>AudioNode</code>, creating a cycle. This is allowed only if there is at least one {{domxref("DelayNode")}} in the cycle. Otherwise, a <code>NotSupportedError</code> exception is thrown. This parameter is not allowed if the destination is an {{domxref("AudioParam")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>If the destination is a node, <code>connect()</code> returns a reference to the destination {{domxref("AudioNode")}} object, allowing you to chain multiple <code>connect()</code> calls. In some browsers, older implementations of this interface return {{jsxref("undefined")}}.</p>

<p>If the destination is an <code>AudioParam</code>, <code>connect()</code> returns <code>undefined</code>.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt><code>IndexSizeError</code></dt>
 <dd>The value specified as <code>outputIndex</code> or <code>inputIndex</code> doesn't correspond to an existing input or output.</dd>
 <dt><code>InvalidAccessError</code></dt>
 <dd>The destination node is not part of the same audio context as the source node.</dd>
 <dt><code>NotSupportedError</code></dt>
 <dd>The specified connection would create a cycle (in which the audio loops back through the same nodes repeatedly) and there are no {{domxref("DelayNode")}}s in the cycle to prevent the resulting waveform from getting stuck constructing the same audio frame indefinitely.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Connecting_to_an_audio_input">Connecting to an audio input</h3>

<p>The most obvious use of the <code>connect()</code> method is to direct the audio output from one node into the audio input of another node for further processing. For example, you might send the audio from a {{domxref("MediaElementAudioSourceNode")}}—that is, the audio from an HTML5 media element such as {{HTMLElement("audio")}}—through a band pass filter implemented using a {{domxref("BiquadFilterNode")}} to reduce noise before then sending the audio along to the speakers.</p>

<p>This example creates an oscillator, then links it to a gain node, so that the gain node controls the volume of the oscillator node.</p>

<pre class="brush: js" style="font-size: 14px;">var AudioContext = window.AudioContext || window.webkitAudioContext;

var audioCtx = new AudioContext();

var oscillator = audioCtx.createOscillator();
var gainNode = audioCtx.createGain();

oscillator.connect(gainNode);
gainNode.connect(audioCtx.destination);
</pre>

<h3 id="AudioParam_example">AudioParam example</h3>

<p>In this example, we will be altering the gain value of a {{domxref("GainNode")}} using an {{domxref("OscillatorNode")}} with a slow frequency value. This technique is know as an <em>LFO</em>-controlled parameter.</p>

<pre class="brush: js;highlight[8,9]">var AudioContext = window.AudioContext || window.webkitAudioContext;

var audioCtx = new AudioContext();

// create an normal oscillator to make sound
var oscillator = audioCtx.createOscillator();

// create a second oscillator that will be used as an LFO (Low-frequency
// oscillator), and will control a parameter
var lfo = audioCtx.createOscillator();

// set the frequency of the second oscillator to a low number
lfo.frequency.value = 2.0; // 2Hz: two oscillations par second

// create a gain whose gain AudioParam will be controlled by the LFO
var gain = audioCtx.createGain();

// connect the LFO to the gain AudioParam. This means the value of the LFO
// will not produce any audio, but will change the value of the gain instead
lfo.connect(gain.gain);

// connect the oscillator that will produce audio to the gain
oscillator.connect(gain);

// connect the gain to the destination so we hear sound
gain.connect(audioCtx.destination);

// start the oscillator that will produce audio
oscillator.start();

// start the oscillator that will modify the gain value
lfo.start();</pre>

<h4 id="AudioParam_notes">AudioParam notes</h4>

<p>It is possible to connect an <code>AudioNode</code> output to more than one {{ domxref("AudioParam") }}, and more than one AudioNode output to a single {{ domxref("AudioParam") }}, with multiple calls to <code>connect()</code>. <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Fan-in_and_Fan-out">Fan-in and fan-out</a> are therefore supported.</p>

<p>An {{ domxref("AudioParam") }} will take the rendered audio data from any <code>AudioNode</code> output connected to it and convert it to mono by <a href="/en-US/docs/Web/API/Web_Audio_API/Basic_concepts_behind_Web_Audio_API#Up-mixing_and_down-mixing">down-mixing</a> (if it is not already mono). Next, it will mix it together with any other such outputs, and the intrinsic parameter value (the value the {{ domxref("AudioParam") }} would normally have without any audio connections), including any timeline changes scheduled for the parameter.</p>

<p>Therefore, it is possible to choose the range in which an {{domxref("AudioParam")}} will change by setting the value of the {{domxref("AudioParam")}} to the central frequency, and to use a {{domxref("GainNode")}} between the audio source and the {{domxref("AudioParam")}} to adjust the range of the {{domxref("AudioParam")}} changes.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audionode-connect', 'connect() to an AudioNode')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('Web Audio API', '#dom-audionode-connect-destinationparam-output', 'connect() to an AudioParam')}}</td>
   <td>{{Spec2('Web Audio API')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.AudioNode.connect")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Audio_API/Using_Web_Audio_API">Using the Web Audio API</a></li>
</ul>
